<template>
  <q-dialog v-model="showDialog" @hide="closeDialog" persistent>
    <q-card style="width: 900px; max-width: 80vw">
      <q-bar>
        Agregar nuevos participantes al evento
        <q-space />
        <q-btn dense flat icon="close" v-close-popup @click="CancelarDialog">
          <q-tooltip>Close</q-tooltip>
        </q-btn>
      </q-bar>

      <q-card-section v-if="step == 1">
        <q-banner inline-actions class="text-white bg-green">
          Las personas inscritas por este medio <strong> NO </strong>recibirán
          ningún tipo de notificación.
        </q-banner>
      </q-card-section>
      <q-card-section class="q-pa-none">
        <q-stepper flat v-model="step" ref="stepper" color="primary" animated>
          <q-step
            :name="1"
            title="Ingreso de Documento"
            icon="person_search"
            :done="step > 1"
          >
            <q-input
              v-model="documentos"
              filled
              type="textarea"
              rows="10"
              placeholder="Ingrese un listado de documento"
            />
          </q-step>

          <q-step
            :name="2"
            title="Confirmacion de datos"
            icon="group_add"
            :done="step > 2"
          >
            <q-list separator dense>
              <q-item
                clickable
                v-ripple
                v-for="persona in dataSet"
                :key="persona.uuid"
              >
                <q-item-section>
                  <PersonaDetalle :persona="persona" />
                </q-item-section>
                <q-item-section>
                  <PersonasFunciones :funciones="persona.funciones" />
                </q-item-section>
              </q-item>
            </q-list>
          </q-step>

          <template v-slot:navigation>
            <q-stepper-navigation>
              <q-btn
                color="green"
                v-if="step === 1"
                @click="buscarDocumentos"
                label="Procesar Documetos"
              />
              <q-btn
                color="red"
                v-if="step === 2"
                @click="agregarParticipantes"
                label="Confirmar"
              />
              <q-btn
                color="green"
                v-if="step === 2"
                label="Cancelar"
                @click="$refs.stepper.previous()"
                class="q-ml-sm"
              />
            </q-stepper-navigation>
          </template>
        </q-stepper>

        <Loading :showing="loading" text="Procesando documentos ..." />
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<script lang="ts">
import { defineComponent, ref, watch } from 'vue';
import { api } from 'src/boot/axios/index';
import { useRoute } from 'vue-router';
import { useQuasar } from 'quasar';
import PersonaDetalle from 'components/Personas/Detalle.vue';
import PersonasFunciones from 'components/Personas/Funciones.vue';
import { PersonaBasicaInterface } from 'src/interfaces/PersonasInterface';
import Loading from 'src/components/Loading.vue';

export default defineComponent({
  name: 'AccionesAgregarParticipantesPartial',
  components: {
    Loading,
    PersonaDetalle,
    PersonasFunciones,
  },
  props: {
    show: Boolean,
  },
  emits: ['update:show', 'close'],

  setup(props, { emit }) {
    const route = useRoute();
    const uuid = route.params.uuid || '';
    const loading = ref<boolean>(false);
    const $q = useQuasar();

    const step = ref(1);
    const showDialog = ref(props.show);

    watch(
      () => props.show,
      (newValue) => {
        showDialog.value = newValue;
      }
    );

    const documentos = ref('');
    const dataSet = ref<PersonaBasicaInterface[]>([]);

    function buscarDocumentos() {
      if (documentos.value.trim() === '') {
        $q.notify({
          message: 'Debe ingresar un documento',
          color: 'red',
          position: 'top',
        });
        return;
      }
      loading.value = true;
      api
        .post('/api/persona/personas/busqueda/masiva', {
          documentos: documentos.value,
        })
        .then((response) => {
          dataSet.value = response.data.data;
          step.value = 2;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    function agregarParticipantes() {
      loading.value = true;
      api
        .post('/api/eventos/inscriptos/masivo', {
          personas: dataSet.value.map(function (a: PersonaBasicaInterface) {
            return a.uuid;
          }),
          uuid: uuid,
        })
        .finally(() => {
          loading.value = false;
          documentos.value = '';
          closeDialog();
        });
    }

    function CancelarDialog() {
      $q.notify({
        message: 'Accion de agregar nuevos participantes cancelada',
        color: 'red',
        position: 'top',
      });
      closeDialog();
    }

    function closeDialog() {
      showDialog.value = false;
      documentos.value = '';
      step.value = 1;
      loading.value = false;
      emit('update:show', false);
      emit('close');
    }

    return {
      step,
      dataSet,
      loading,
      showDialog,
      closeDialog,
      CancelarDialog,
      documentos,
      agregarParticipantes,
      buscarDocumentos,
    };
  },
});
</script>
